/*
 * Copyright 2018 Google, Inc.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are
 * met: redistributions of source code must retain the above copyright
 * notice, this list of conditions and the following disclaimer;
 * redistributions in binary form must reproduce the above copyright
 * notice, this list of conditions and the following disclaimer in the
 * documentation and/or other materials provided with the distribution;
 * neither the name of the copyright holders nor the names of its
 * contributors may be used to endorse or promote products derived from
 * this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#ifndef __SYSTEMC_EXT_DT_BIT_MESSAGES_HH__
#define __SYSTEMC_EXT_DT_BIT_MESSAGES_HH__

namespace sc_core
{

extern const char SC_ID_LENGTH_MISMATCH_[];
extern const char SC_ID_INCOMPATIBLE_TYPES_[];
extern const char SC_ID_CANNOT_CONVERT_[];
extern const char SC_ID_INCOMPATIBLE_VECTORS_[];
extern const char SC_ID_VALUE_NOT_VALID_[];
extern const char SC_ID_ZERO_LENGTH_[];
extern const char SC_ID_VECTOR_CONTAINS_LOGIC_VALUE_[];
extern const char SC_ID_SC_BV_CANNOT_CONTAIN_X_AND_Z_[];
extern const char SC_ID_VECTOR_TOO_LONG_[];
extern const char SC_ID_VECTOR_TOO_SHORT_[];
extern const char SC_ID_WRONG_VALUE_[];
extern const char SC_ID_LOGIC_Z_TO_BOOL_[];
extern const char SC_ID_LOGIC_X_TO_BOOL_[];

} // namespace sc_core

#endif // __SYSTEMC_EXT_DT_BIT_MESSAGES_HH__
